VERSION 5.00
Begin VB.Form FrmAdvancedChk 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Advanced file checker"
   ClientHeight    =   2730
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6090
   ControlBox      =   0   'False
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2730
   ScaleWidth      =   6090
   StartUpPosition =   2  'CenterScreen
   Begin VB.PictureBox PictFrm 
      Height          =   2775
      Index           =   0
      Left            =   0
      ScaleHeight     =   2715
      ScaleWidth      =   6075
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   0
      Width           =   6135
      Begin VB.CommandButton CmdContinue 
         Caption         =   "C&ontinue..."
         Height          =   435
         Left            =   4560
         TabIndex        =   8
         Top             =   2160
         Width           =   1335
      End
      Begin VB.CommandButton CmdCancel 
         Caption         =   "&Cancel"
         Height          =   435
         Left            =   3120
         TabIndex        =   7
         Top             =   2160
         Width           =   1335
      End
      Begin VB.Image imgIcon 
         Height          =   480
         Index           =   3
         Left            =   720
         Picture         =   "FrmAdvancedChk.frx":0000
         Top             =   840
         Width           =   480
      End
      Begin VB.Label Label2 
         AutoSize        =   -1  'True
         BackStyle       =   0  'Transparent
         Caption         =   $"FrmAdvancedChk.frx":08CA
         Height          =   900
         Left            =   1920
         TabIndex        =   9
         Top             =   600
         Width           =   3975
         WordWrap        =   -1  'True
      End
      Begin VB.Label Label1 
         AutoSize        =   -1  'True
         BackStyle       =   0  'Transparent
         Caption         =   "Advanced check for errors:"
         Height          =   195
         Left            =   1920
         TabIndex        =   4
         Top             =   240
         Width           =   1935
      End
      Begin VB.Image Image1 
         Height          =   1695
         Left            =   120
         Picture         =   "FrmAdvancedChk.frx":0973
         Top             =   240
         Width           =   1695
      End
   End
   Begin VB.PictureBox PictFrm 
      Appearance      =   0  'Flat
      ForeColor       =   &H80000008&
      Height          =   3810
      Index           =   1
      Left            =   0
      ScaleHeight     =   3780
      ScaleWidth      =   7650
      TabIndex        =   5
      TabStop         =   0   'False
      Top             =   0
      Visible         =   0   'False
      Width           =   7680
      Begin VB.CommandButton Cmd_Cancel 
         Caption         =   "&Cancel"
         Height          =   375
         Left            =   2160
         TabIndex        =   1
         Top             =   3240
         Width           =   1455
      End
      Begin VB.CommandButton CmdGO 
         Caption         =   "&Start..."
         Height          =   375
         Left            =   4200
         TabIndex        =   0
         Top             =   3240
         Width           =   1575
      End
      Begin VB.ListBox ListLog 
         Height          =   2985
         Left            =   2160
         TabIndex        =   6
         Top             =   120
         Width           =   5295
      End
      Begin VB.CommandButton CmdOK 
         Caption         =   "&OK"
         Height          =   375
         Left            =   5880
         TabIndex        =   2
         Top             =   3240
         Visible         =   0   'False
         Width           =   1575
      End
      Begin VB.Image Image2 
         Height          =   1695
         Left            =   240
         Picture         =   "FrmAdvancedChk.frx":1A97
         Top             =   720
         Width           =   1695
      End
   End
End
Attribute VB_Name = "FrmAdvancedChk"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim Clicked_Cancel As Boolean

Private Sub Cmd_Cancel_Click()
    Clicked_Cancel = True
    If CmdGO.Enabled = True Then Unload Me
End Sub

Private Sub CmdCancel_Click()
    Unload Me
End Sub

Private Sub CmdContinue_Click()

    Me.Width = 7755
    Me.Height = 4155
    
    Me.Left = Screen.Width / 2 - Me.Width / 2
    Me.Top = Screen.Height / 2 - Me.Height / 2
    
    PictFrm.Item(0).Visible = False
    PictFrm.Item(1).Visible = True

End Sub

Private Sub CmdGO_Click()
    
    Dim ErrorEnable As Boolean
    
    On Error GoTo FinaliseError
    
    Clicked_Cancel = False
    CmdGO.Visible = False
    Me.Refresh
    
    ListLog.AddItem "Checking file for correct header..."
    ListLog.ListIndex = ListLog.ListCount - 1
    ListLog.Refresh
    
    If WinPakValid(ArchiveName) = True Then
        ListLog.AddItem "No problems with file header... continue to file list check..."
        ListLog.ListIndex = ListLog.ListCount - 1
        ListLog.Refresh
    Else
        ListLog.AddItem "Bad file header, cannot continue to read file."
        ListLog.ListIndex = ListLog.ListCount - 1
        ListLog.Refresh
    End If
    
    ListLog.AddItem "Checking file list..."
    ListLog.ListIndex = ListLog.ListCount - 1
    ListLog.Refresh
    
    Dim temp As Integer
    Dim TempName As String
    Dim M As Integer
    
    temp = FileCount(ArchiveName)
    
    ListLog.AddItem temp & " files counted... continuing recovering names..."
    ListLog.ListIndex = ListLog.ListCount - 1
    ListLog.Refresh
    
    For M = 0 To temp - 1
        TempName = GetName(ArchiveName, M)
        If TempName = "" Then
            ListLog.AddItem "<#" & M & " - " & TempName & "> Error detected while reading file..."
            ErrorEnable = True
        Else
            ListLog.AddItem "<#" & M & " - " & TempName & "> Loaded OK..."
        End If
        ListLog.ListIndex = ListLog.ListCount - 1
        ListLog.Refresh
        If Clicked_Cancel = True Then
            MessageBox "Advanced file check canceled by user.", OKOnly, Information
            Unload Me
            Exit Sub
        End If
        DoEvents
    Next M
    
    ListLog.AddItem "File count and checking complete. Checking for comments..."
    ListLog.ListIndex = ListLog.ListCount - 1
    ListLog.Refresh
    
    If WinPakComment(ArchiveName) <> "" Then
        ListLog.AddItem "Comment found... Loading..."
        ListLog.ListIndex = ListLog.ListCount - 1
        ListLog.Refresh
        ListLog.AddItem WinPakComment(ArchiveName)
        ListLog.ListIndex = ListLog.ListCount - 1
        ListLog.Refresh
        ListLog.AddItem "Comment loaded."
        ListLog.ListIndex = ListLog.ListCount - 1
        ListLog.Refresh
    Else
        ListLog.AddItem "No comment detected."
        ListLog.ListIndex = ListLog.ListCount - 1
        ListLog.Refresh
    End If
    
    If ErrorEnable = True Then
        ListLog.AddItem "Error check complete. Possible errors detected. Please read log for more details."
        MessageBox "Error check complete. Possible errors detected. Please read log for more details.", OKOnly, Critical
    Else
        ListLog.AddItem "Error check complete. No errors detected."
        MessageBox "Error check complete. No errors detected.", OKOnly, Information
    End If
        
    ListLog.ListIndex = ListLog.ListCount - 1
    ListLog.Refresh
    Cmd_Cancel.Enabled = False
    CmdOK.Visible = True
            
    Exit Sub
    
FinaliseError:
    
    ListLog.AddItem "Error detected. Please read log for more details."
    ListLog.ListIndex = ListLog.ListCount - 1
    ListLog.Refresh
    CmdOK.Visible = True
    
    MessageBox "Error detected. Please read log for more details.", OKOnly, Critical
    
End Sub

Private Sub CmdOK_Click()
    Unload Me
End Sub
