Attribute VB_Name = "ModComment"
Public Sub CommandShowComment()
    On Error Resume Next
    FrmComment.Show 1, FrmMain
End Sub

Function WinPakComment(WinPak As String) As String
    Select Case File_Method
        Case 0:
            WinPakComment = Get_Type_Comment(WinPak)
    End Select
End Function
    
Function Get_Type_Comment(WinPak As String) As String
    
    Dim FileNumber As Integer
    Dim Offset As Long
    Dim Size As Long
    Dim Name As String
    Dim DirPath As String
    
    On Error GoTo FinaliseError
    If WinPakValid(WinPak) = True Then
        FileNumber = FreeFile
        Open WinPak For Binary As FileNumber
            Get FileNumber, Len(MainHeader) + 1, FileListStart
            If FileListStart > 0 Then
                Do
                    Get FileNumber, FileListStart, Offset: FileListStart = FileListStart + 4
                    Get FileNumber, FileListStart, Size: FileListStart = FileListStart + 4
                    DirPath = String$(65536, Chr$(0)): Get FileNumber, FileListStart, DirPath  'Length posible
                    DirPath = Mid(DirPath, 1, InStr(1, DirPath, Chr$(0)) - 1)
                    FileListStart = FileListStart + Len(DirPath) + 1
                    Name = String$(256, Chr$(0))
                    Get FileNumber, FileListStart, Name 'Length posible
                    Name = Mid(Name, 1, InStr(1, Name, Chr$(0)) - 1)

                    FileListStart = FileListStart + 257
                       
                    If Name = "" Or Offset = 0 Or Size = 0 Then
                        GoTo FinaliseError
                    ElseIf DirPath = MainDataClassHeader Then
                        Select Case Name
                            Case MainDataCommentHeader
                                Dim CommentMessage As String
                                CommentMessage = String(Size, Chr$(0))
                                Get FileNumber, Offset, CommentMessage
                                If CommentMessage = String(4669, Chr(0)) Then
                                    'Do Nothing
                                Else
                                    Get_Type_Comment = CommentMessage
                                End If
                                GoTo FinaliseError
                        End Select
                    End If
                Loop Until FileListStart > LOF(FileNumber)
            End If
    Else
        Exit Function
    End If
FinaliseError:
    Close FileNumber
End Function

Function WinPakRecentComment(WinPak As String) As Boolean
    Select Case File_Method
        Case 0:
            WinPakRecentComment = Get_Type_RecentComment(WinPak)
    End Select
End Function

Function Get_Type_RecentComment(WinPak As String) As Boolean
    
    Dim FileNumber As Integer
    Dim Offset As Long
    Dim Size As Long
    Dim Name As String
    Dim DirPath As String
    
    On Error GoTo FinaliseError
    If WinPakValid(WinPak) = True Then
        FileNumber = FreeFile
        Open WinPak For Binary As FileNumber
            Get FileNumber, Len(MainHeader) + 1, FileListStart
            If FileListStart > 0 Then
                Do
                    Get FileNumber, FileListStart, Offset: FileListStart = FileListStart + 4
                    Get FileNumber, FileListStart, Size: FileListStart = FileListStart + 4
                    DirPath = String$(65536, Chr$(0)): Get FileNumber, FileListStart, DirPath  'Length posible
                    DirPath = Mid(DirPath, 1, InStr(1, DirPath, Chr$(0)) - 1)
                    FileListStart = FileListStart + Len(DirPath) + 1
                    Name = String$(256, Chr$(0))
                    Get FileNumber, FileListStart, Name 'Length posible
                    Name = Mid(Name, 1, InStr(1, Name, Chr$(0)) - 1)
                    FileListStart = FileListStart + 257
                       
                    If Name = "" Or Offset = 0 Or Size = 0 Then
                        GoTo FinaliseError
                    ElseIf Name = MainDataCommentHeader Then
                        Dim CommentMessage As String
                        CommentMessage = String(Size, Chr$(0))
                        Get FileNumber, Offset, CommentMessage
                        If CommentMessage = String(4669, Chr(0)) Then Get_Type_RecentComment = True
                        GoTo FinaliseError
                    End If
                Loop Until FileListStart > LOF(FileNumber)
            End If
    Else
        Exit Function
    End If
FinaliseError:
    Close FileNumber
End Function
