Attribute VB_Name = "ModDelete"
Function RemoveDirectory(Path As String) As Boolean
    On Error GoTo FinaliseError
    RmDir Path
    RemoveDirectory = True
    Exit Function
FinaliseError:
    RemoveDirectory = False
End Function

Function DeleteFileFromPak(WinPak As String, FileList As ListView) As Boolean

    Dim DataString_01 As String

    On Error GoTo FinaliseError

    FrmBusy.lblStatus.Caption = "Saving archive information..."
    SetPanelCaption "Saving archive information...", False
    FrmBusy.Refresh

    Dim FullPath As String

    Randomize Timer

    If Right(TrimNull(GetTemporaryFileName), 1) = "\" Or Right(TrimNull(GetTemporaryFileName), 1) = "/" Then
        FullPath = TrimNull(GetTemporaryFileName)
        FullPath = FullPath & "WC" & Rnd * 999999 & "\"
        MkDir FullPath
    Else
        FullPath = TrimNull(GetTemporaryFileName) & "\"
        FullPath = FullPath & "WC" & Rnd * 999999 & "\"
        MkDir FullPath
    End If

    WinPakCreate CStr(WinPak & ".$tmp")

    DataString_01 = GetInformation(WinPak, MainDataCommentHeader)
    
    DoEvents
    
    If DataString_01 <> "" Then
        If AddInformation(WinPak & ".$tmp", MainDataCommentHeader, DataString_01) = False Then
            MessageBox "Error, could not re-add the comment to the archive.", OKOnly, Information
            DataString_01 = ""
        Else
            DataString_01 = ""
        End If
    End If

    For M = 1 To FrmMain.ListFiles.ListItems.Count
        DoEvents
        If FrmMain.ListFiles.ListItems.Item(M).Selected = False Then
            If WinPakExtract(WinPak, FrmMain.ListFiles.ListItems.Item(M).Text, FullPath & FrmMain.ListFiles.ListItems.Item(M).Text) = False Then
                MessageBox "Error, could not delete reqested file.", OKOnly, Critical
                SetPanelCaption "", True
                Exit Function
            End If
            SetPanelCaption "Storing " & FrmMain.ListFiles.ListItems.Item(M).Text, False
            FrmBusy.lblStatus.Caption = "Storing " & FrmMain.ListFiles.ListItems.Item(M).Text
            FrmBusy.Refresh
        End If
        DoEvents
        If FrmMain.ListFiles.ListItems.Item(M).Selected = True Then
            FrmBusy.lblStatus.Caption = "Deleting " & FrmMain.ListFiles.ListItems.Item(M).Text
            SetPanelCaption "Deleting " & FrmMain.ListFiles.ListItems.Item(M).Text, False
            FrmBusy.Refresh
        Else
            If WinPakAdd(CStr(WinPak & ".$tmp"), FullPath & FrmMain.ListFiles.ListItems.Item(M).Text, FrmMain.ListFiles.ListItems.Item(M).Text, FrmMain.ListFiles.ListItems.Item(M).SubItems(4)) = True Then
                If KillFile(FullPath & FrmMain.ListFiles.ListItems.Item(M).Text) = True Then
                    SetPanelCaption "Removing temp " & FrmMain.ListFiles.ListItems.Item(M).Text, False
                Else
                    MessageBox "Error, could not delete reqested file.", OKOnly, Critical
                    SetPanelCaption "", True
                    Exit Function
                End If
            Else
                MessageBox "Error, could not delete reqested file.", OKOnly, Critical
                SetPanelCaption "", True
                Exit Function
            End If
        End If
        FrmBusy.ctlProgress2.Value = ((M / FrmMain.ListFiles.ListItems.Count) * 100)
        DoEvents
    Next M

    If KillFile(WinPak) = True Then
        DoEvents
        SetPanelCaption "Moving file...", False
        If MoveFile(CStr(WinPak & ".$tmp"), WinPak, True) = True Then
            If FileExist(CStr(WinPak & ".$tmp")) = True Then
                If KillFile(CStr(WinPak & ".$tmp")) = False Then
                    MessageBox "Could not remove temporary file for the WinCrypt archive.", OKOnly, Critical
                    SetPanelCaption "", True
                    Exit Function
                Else
                    If RemoveDirectory(FullPath) = False Then
                        MessageBox "Could not remove temporary folder, but the delete operation was complete.", OKOnly, Critical
                        SetPanelCaption "", True
                        Exit Function
                    End If
                End If
            Else
                MessageBox "Could not remove temporary file for the WinCrypt archive.", OKOnly, Critical
                SetPanelCaption "", True
                Exit Function
            End If
            DeleteFileFromPak = True
            SetPanelCaption "", True
        Else
            SetPanelCaption "", True
        End If
        DoEvents
    Else
        SetPanelCaption "", True
    End If
    Exit Function

FinaliseError:
    SetPanelCaption "", True

End Function
