Attribute VB_Name = "ModExtract"
Function WinPakExtract(WinPak As String, FileToExtract As String, DestinationFile As String) As Boolean
    Select Case File_Method
        Case 0:
            WinPakExtract = Get_Type_WPK(WinPak, FileToExtract, DestinationFile)
    End Select
End Function

Function Get_Type_WPK(WinPak As String, FileToExtract As String, DestinationFile As String) As Boolean

    On Error GoTo FinaliseError
    
    Dim BytesExtract As String
    Dim Offset As Long
    Dim Size As Long
    Dim Name As String
    Dim DirPath As String

    FileNumber = FreeFile
    If WinPakValid(WinPak) = True Then
        
        Open WinPak For Binary As FileNumber
            Get FileNumber, Len(MainHeader) + 1, FileListStart
            If FileListStart > 0 Then
                Do
                    Get FileNumber, FileListStart, Offset
                    FileListStart = FileListStart + 4
                
                    Get FileNumber, FileListStart, Size
                    FileListStart = FileListStart + 4
                    
                    DirPath = String$(65536, Chr$(0))
                    Get FileNumber, FileListStart, DirPath  'Length posible
                    DirPath = Mid(DirPath, 1, InStr(1, DirPath, Chr$(0)) - 1)
                    FileListStart = FileListStart + Len(DirPath) + 1
                
                    Name = String$(256, Chr$(0)) 'Over length posible
                    Get FileNumber, FileListStart, Name
                    Name = Mid(Name, 1, InStr(1, Name, Chr$(0)) - 1)
                    FileListStart = FileListStart + 257
                                                        
                    If Name = "" Or Offset = 0 Or Size = 0 Then
                        GoTo FinaliseError
                    ElseIf LCase(Name) = LCase(FileToExtract) Then
                        If FrmBusy.Visible = True Then FrmBusy.lblStatus = "Extracting - " & FileToExtract: FrmBusy.Refresh
                        If FrmExtractDir.Visible = True Then FrmExtractDir.lblStatus = "Extracting - " & FileToExtract: FrmExtractDir.Refresh

                        DestinationNumber = FreeFile
                        Open DestinationFile For Binary As DestinationNumber
                            If Size > 100000 Then
                                Position = -1000000
                                If FrmBusy.Visible = True Then FrmBusy.ctlProgress1.Max = Size
                                If FrmExtractDir.Visible = True Then FrmExtractDir.ctlProgress1.Max = Size
                                Do
                                    Position = Position + 1000000
                                    If Position + 999999 > Size Then
                                        BytesExtract = String(Size - Position, Chr$(0))
                                        If FrmBusy.Visible = True Then FrmBusy.ctlProgress1.Value = FrmBusy.ctlProgress1.Max
                                        If FrmBusy.Visible = True Then FrmBusy.Refresh
                                        
                                        If FrmExtractDir.Visible = True Then FrmExtractDir.ctlProgress1.Value = FrmExtractDir.ctlProgress1.Max
                                        If FrmExtractDir.Visible = True Then FrmExtractDir.Refresh
                                    Else
                                        BytesExtract = String(1000000, Chr$(0))
                                        If FrmBusy.Visible = True Then FrmBusy.ctlProgress1.Value = Position
                                        If FrmBusy.Visible = True Then FrmBusy.Refresh
                                        
                                        If FrmExtractDir.Visible = True Then FrmExtractDir.ctlProgress1.Value = Position
                                        If FrmExtractDir.Visible = True Then FrmExtractDir.Refresh
                                    End If
                                    Get FileNumber, Position + Offset, BytesExtract
                                    Put DestinationNumber, Position + 1, BytesExtract
                                    DoEvents
                                Loop Until Position + 999999 >= Size
                            Else
                                BytesExtract = String(Size, Chr$(0))
                                Get FileNumber, Offset, BytesExtract
                                Put DestinationNumber, 1, BytesExtract
                            End If
                        Get_Type_WPK = True
                        GoTo FinaliseError
                    End If
                Loop Until FileListStart > LOF(FileNumber)
            End If
    Else
        Exit Function
    End If
FinaliseError:
    Close DestinationNumber
    Close FileNumber
End Function
