Attribute VB_Name = "ModFolders"
Public Const SetSep As String = "|"
Public Const FileKey As String = "?"

Dim Load_Local_ErrorNodes As Boolean

Public Function CreateFolders(Treebox As TreeView, Path As String, PacFile As String)

    Lastpos = 1
    lastfolder = GetFileName(PacFile)
    On Local Error Resume Next
    Do
        Nextpos = InStr(Lastpos, Path, "\")
        If Nextpos > Lastpos Then
            nextfolder = GetFileName(PacFile) & "\" & Left(Path, Nextpos - 1)
            Treebox.Nodes.Add lastfolder, 4, nextfolder, GetFileName(CStr(nextfolder)), 3, 4
            lastfolder = nextfolder
            Lastpos = Nextpos + 1
        Else
            Exit Do
        End If
    Loop

End Function

Public Sub CreatePathList(Treebox As TreeView, SepList As String, PacFile As String)

    Dim CurPath As String
    
    Load_Local_ErrorNodes = False
    
    Treebox.Nodes.Clear
    Treebox.Nodes.Add , , GetFileName(PacFile), GetFileName(PacFile), 1, 2
    Treebox.Nodes(1).Expanded = True
    'Add folders
    Lastpos = 1
    Do
        Nextpos = InStr(Lastpos, SepList, SetSep)
        If Nextpos > Lastpos Then
            CurPath = Mid(SepList, Lastpos, Nextpos - Lastpos)
            CreateFolders Treebox, CurPath, PacFile
            Lastpos = Nextpos + 1
        Else
            Exit Do
        End If
    Loop
    'Add files
    Lastpos = 1
    
    Dim Node_Count As Integer
    
    Do
        Node_Count = Node_Count + 1
        Nextpos = InStr(Lastpos, SepList, SetSep)
        If Nextpos > Lastpos Then
            CurPath = Mid(SepList, Lastpos, Nextpos - Lastpos)
            If InStr(1, CurPath, "\") > 0 Then
                Unload FrmSplash
                If Left(CurPath, 1) = "\" Or Left(CurPath, 1) = "/" Then
                    Add_Node Treebox, Node_Count, GetFileName(PacFile), 4, FileKey & GetFileName(PacFile) & "\" & Right(CurPath, Len(CurPath) - 1), Right(CurPath, Len(CurPath) - 1), 5
                Else
                    Add_Node Treebox, Node_Count, GetFileName(PacFile) & "\" & GetPathname(CurPath), 4, FileKey & GetFileName(PacFile) & "\" & CurPath, GetFileName(CurPath), 5
                End If
            Else
                Add_Node Treebox, Node_Count, GetFileName(PacFile), 4, FileKey & GetFileName(PacFile) & "\" & CurPath, CurPath, 5
            End If
            Lastpos = Nextpos + 1
        Else
            Exit Do
        End If
    Loop
    
    If Load_Local_ErrorNodes = True Then Load_NodeErrors

End Sub

Private Function Add_Node(Treebox As TreeView, NodeCount As Integer, Relative As String, Relationship As Integer, Key As String, Text As String, Image As Integer, Optional ImageSelected As Integer)
    On Error GoTo FinaliseError
    Treebox.Nodes.Add Relative, Relationship, Key, Text, Image, ImageSelected
    Exit Function
FinaliseError:
    FrmErrorNodes.List_Nodes.ListItems.Add , , Node_Count
    FrmErrorNodes.List_Nodes.ListItems.Item(FrmErrorNodes.List_Nodes.ListItems.Count).SubItems(1) = CurPath
    Load_Local_ErrorNodes = True
End Function

Private Sub Load_NodeErrors()
    On Error Resume Next
    Load_Local_ErrorNodes = False
    FrmErrorNodes.Show 1, FrmMain
End Sub
