Attribute VB_Name = "ModListViewFeatures"
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Const SWP_DRAWFRAME = &H20
Const SWP_NOMOVE = &H2
Const SWP_NOSIZE = &H1
Const SWP_NOZORDER = &H4

Public Const LVIF_STATE = &H8

Private Const HDS_BUTTONS = &H2
Private Const GWL_STYLE = (-16)
Private Const SWP_FLAGS = SWP_NOZORDER Or SWP_NOSIZE Or SWP_NOMOVE Or SWP_DRAWFRAME

Public Function EnhListView_Toggle_FlatColumnHeaders(frmFormName As Form, lstListViewName As ListView) As Boolean
    
    On Error GoTo err_EnhListView_Toggle_FlatColumnHeaders
    EnhListView_Toggle_FlatColumnHeaders = True
    SetWindowLong SendMessageLong(lstListViewName.hwnd, LVM_GETHEADER, 0, ByVal 0&), GWL_STYLE, GetWindowLong(SendMessageLong(lstListViewName.hwnd, LVM_GETHEADER, 0, ByVal 0&), GWL_STYLE) Xor HDS_BUTTONS
    SetWindowPos lstListViewName.hwnd, frmFormName.hwnd, 0, 0, 0, 0, SWP_FLAGS
    Exit Function

err_EnhListView_Toggle_FlatColumnHeaders:
    EnhListView_Toggle_FlatColumnHeaders = False
    Exit Function
End Function


