Attribute VB_Name = "ModMain"
Global Const MainHeader As String = "wpk.01"
Global Const MainDataClassHeader As String = "Directory/Class_Data"
Global Const MainDataCommentHeader As String = "Comment/Class_Data"
Global FileListStart As Long
Global FileNumberAdd As Long
Global FileNumberPak As Long
Global ArchiveName As String
Global FileList As String
Global DoCount As Long
Global Offset As Long
Global Name As String
Global Size As Long
Public VirusScan As String
Public Parameters As String
Public Viewer As String
Public RunMinimized As Boolean
Public AutoSize As Boolean
Public AutoFit As Boolean
Public PromptDelete As Boolean
Public CommentPopup As Boolean
Public DelSuccessPopup As Boolean
Public PromptRename As Boolean
Public PromptRenameSuccess As Boolean
Public LastDrive As String
Public LocationDrive As String
Public LocationPath As String
Public DirectoryPattern As String
Public HideBrowseTools As Boolean
Public FoldersString As String

Public Const MAX_PATH = 260

''''''''''''''''''''''''''''''
Public File_Method As Integer ' - NOTE
                              'If you adding different file structures to the application
                              'each structure MUST have it's own index.
                              'Default structure = 0
''''''''''''''''''''''''''''''

Global OffSetTypes(0 To 999999) As Long
Global SizeTypes(0 To 999999) As Long

Public Function GetPathname(Path As String) As String

    For FindSep = 1 To Len(Path)
        If Mid(Path, Len(Path) - (FindSep - 1), 1) = "\" Or Mid(Path, Len(Path) - (FindSep - 1), 1) = "/" Then
            GetPathname = Left(Path, Len(Path) - FindSep)
            Exit Function
        End If
    Next FindSep

End Function

Function GetFileName(Path As String) As String

    For FindSep = 1 To Len(Path)
        If Mid(Path, Len(Path) - (FindSep - 1), 1) = "\" Or Mid(Path, Len(Path) - (FindSep - 1), 1) = "/" Then
            GetFileName = Right(Path, FindSep - 1)
            Exit Function
        End If
    Next FindSep

End Function

Function GetPath(FullPath As String) As String
    
    Dim C As Integer
    Dim S As Integer
    Dim J As Integer

    C = 0
    S = 0
    J = 0
    
    For M = 1 To Len(FullPath)
        GetChr0 = Right(FullPath, M)
        GetChr1 = Left(GetChr0, 1)
        If GetChr1 = "\" Or GetChr1 = "/" Then
            C = C + 1
        End If
    Next M
    For M = 1 To Len(FullPath)
        GetChr0 = Left(FullPath, M)
        GetChr1 = Right(GetChr0, 1)
        J = J + 1
        If GetChr1 = "\" Or GetChr1 = "/" Then
            J = 0
            S = S + 1
            If S = C Then
                GetPath = Right(GetChr0, M - J)
                Exit Function
            End If
        End If
    Next M

End Function

Function GetSubDir(OutdentPath As String, FullPath As String) As String

    If Right(OutdentPath, 1) <> "\" Then OutdentPath = OutdentPath & "\"
    If Right(FullPath, 1) <> "\" Then FullPath = FullPath & "\"
    
    If Right(FullPath, Len(FullPath) - Len(OutdentPath)) = "" Then
        GetSubDir = ""
    Else
        GetSubDir = Right(FullPath, Len(FullPath) - Len(OutdentPath))
    End If
    
End Function

Function GetSubDir_And_Current(OutdentPath As String, FullPath As String, Optional StoredIndentFolders As Boolean) As String

    Dim TempExt As String

    TempExt = GetFileName(OutdentPath)

    OutdentPath = Left(OutdentPath, Len(OutdentPath) - Len(GetFileName(OutdentPath)))

    If Right(OutdentPath, 1) <> "\" Then OutdentPath = OutdentPath & "\"
    If Right(FullPath, 1) <> "\" Then FullPath = FullPath & "\"
    
    If Right(FullPath, Len(FullPath) - Len(OutdentPath)) = "" Then
        GetSubDir_And_Current = ""
    Else
        If StoredIndentFolders = True Then
            GetSubDir_And_Current = Right(FullPath, Len(FullPath) - Len(OutdentPath))
        Else
            GetSubDir_And_Current = TempExt & "\"
        End If
    End If
    
End Function

Public Function FormatKB(ByVal Amount As Long) As String
    Dim Buffer As String
    Dim result As String
    Buffer = Space$(255)
    result = StrFormatByteSize(Amount, Buffer, Len(Buffer))
    If InStr(result, vbNullChar) > 1 Then FormatKB = Left$(result, InStr(result, vbNullChar) - 1)
End Function

Public Function FolderExist(Pathn As String) As Boolean
    If Dir$(Pathn) = "" Then FolderExist = False Else FolderExist = True
End Function

Function FileExist(Filename As String) As Boolean
    On Error GoTo Erro
    If FileLen(Filename) <> 0 Then
        FileExist = True
    Else
        FileExist = False
    End If
    Exit Function
Erro:
    If Err = 76 Or Err = 53 Then FileExist = False
End Function

Public Function GetTemporaryFileName(Optional Prefix As String = "") As String
    On Error Resume Next
    Dim lngReturnVal As Long
    Dim strTempPath As String * 255
    lngReturnVal = GetTempPath(254, strTempPath)
    GetTemporaryFileName = strTempPath
End Function

Public Function GetShortName(ByVal sLongFileName As String) As String
    On Error Resume Next
    Dim lRetVal As Long, sShortPathName As String, iLen As Integer
    sShortPathName = Space(255)
    iLen = Len(sShortPathName)
    lRetVal = GetShortPathName(sLongFileName, sShortPathName, iLen)
    GetShortName = Left(sShortPathName, lRetVal)
End Function

Function KillFile(Filename As String) As Boolean
    
    On Error GoTo FinaliseError
    KillFile = True
    
    If WinPakValid(Filename) = True Then
        Kill Filename
    Else
        Kill Filename
    End If
    
    Exit Function
FinaliseError:
    KillFile = False
    
End Function

Public Sub CentrePic(Target As PictureBox, Source As StdPicture)
    On Error Resume Next
    Dim PicWidth As Integer
    Dim PicHeight As Integer
    Dim NewWidth As Integer
    Dim NewHeight As Integer
    Dim CenterX As Integer
    Dim CenterY As Integer
    PicWidth = Source.Width / 16.763
    PicHeight = Source.Height / 16.763
    Aspect = PicWidth / PicHeight
    If PicWidth > PicHeight Then
        NewWidth = Target.Width - 240
        NewHeight = Target.Width / Aspect
    Else
        NewWidth = Target.Height * Aspect
        NewHeight = Target.Height - 240
    End If
    CenterX = Target.Width / 2 - NewWidth / 2
    CenterY = Target.Height / 2 - NewHeight / 2
    Target.PaintPicture Source, CenterX, CenterY, NewWidth, NewHeight
End Sub

Public Function TrimNull(Item As String)
    Dim pos As Integer
    pos = InStr(Item, Chr$(0))
    If pos Then
        TrimNull = Left$(Item, pos - 1)
    Else: TrimNull = Item
    End If
End Function
