Attribute VB_Name = "ModMsgBox"
Global result As Integer

Public Enum Buttons
    OKOnly = 0
    OKCancel = 1
    YesNo = 2
    YesNoCancel = 3
    RetryCancel = 4
    AbortRetryIgnore = 5
End Enum

Public Enum Icons
    Critical = 0
    Question = 1
    Warning = 2
    Information = 3
    None = 4
End Enum

Public Function MessageBox(MsgMessage As String, Buttons As Buttons, Icon As Icons)
    frmMessage.lblMessage = MsgMessage
    
    'Erase all icons
    For Index = 0 To 3
        frmMessage.imgIcon(Index).Visible = False
    Next Index
    
    If Icon <> None Then frmMessage.imgIcon(Icon).Visible = True
    
    'Erase all buttons
    For Index = 0 To 2
        frmMessage.PctButton(Index).Visible = False
        frmMessage.PctButton(Index).FontBold = False
    Next Index
    
    
    If Buttons = AbortRetryIgnore Then
        frmMessage.PctButton(0).Visible = True
        frmMessage.PctButton(0).Caption = "Retry"
        frmMessage.PctButton(0).FontBold = True
        
        frmMessage.PctButton(1).Visible = True
        frmMessage.PctButton(1).Caption = "Ignore"
        
        frmMessage.PctButton(2).Visible = True
        frmMessage.PctButton(2).Caption = "Abort"
    
    ElseIf Buttons = OKCancel Then
        frmMessage.PctButton(0).Visible = True
        frmMessage.PctButton(0).Caption = "OK"
        frmMessage.PctButton(0).FontBold = True
        
        frmMessage.PctButton(1).Visible = True
        frmMessage.PctButton(1).Caption = "Cancel"
    
    ElseIf Buttons = OKOnly Then
        frmMessage.PctButton(0).Visible = True
        frmMessage.PctButton(0).Caption = "OK"
        frmMessage.PctButton(0).FontBold = True
        
    ElseIf Buttons = RetryCancel Then
        frmMessage.PctButton(0).Visible = True
        frmMessage.PctButton(0).Caption = "Retry"
        frmMessage.PctButton(0).FontBold = True
        
        frmMessage.PctButton(1).Visible = True
        frmMessage.PctButton(1).Caption = "Cancel"
    
    ElseIf Buttons = YesNoCancel Then
        frmMessage.PctButton(0).Visible = True
        frmMessage.PctButton(0).Caption = "Yes"
        frmMessage.PctButton(0).FontBold = True
        
        frmMessage.PctButton(1).Visible = True
        frmMessage.PctButton(1).Caption = "No"
    
        frmMessage.PctButton(2).Visible = True
        frmMessage.PctButton(2).Caption = "Cancel"
    
    ElseIf Buttons = YesNo Then
        frmMessage.PctButton(0).Visible = True
        frmMessage.PctButton(0).Caption = "Yes"
        frmMessage.PctButton(0).FontBold = True
        
        frmMessage.PctButton(1).Visible = True
        frmMessage.PctButton(1).Caption = "No"
    
    End If
    
    frmMessage.Show 1
End Function
