Attribute VB_Name = "ModReplaceInformation"
Function ReplaceInformation(WinPak As String, DataName As String, Data As String) As Boolean
    Select Case File_Method
        Case 0:
            ReplaceInformation = WPK_Type_ReplaceInfo(WinPak, DataName, Data)
    End Select
End Function

Function WPK_Type_ReplaceInfo(WinPak As String, DataName As String, Data As String) As Boolean
    
    On Error GoTo FinaliseError
    
    Dim FileNumberPak As Integer
    Dim FileNumber As Integer
    Dim Offset As Long
    Dim Size As Long
    Dim Name As String
    Dim DirPath As String
   
    FileNumber = FreeFile
    Open WinPak For Binary As FileNumber
        Get FileNumber, Len(MainHeader) + 1, FileListStart
        If FileListStart > 0 Then
            Do
                Get FileNumber, FileListStart, Offset: FileListStart = FileListStart + 4
                Get FileNumber, FileListStart, Size: FileListStart = FileListStart + 4
                
                DirPath = String$(65536, Chr$(0))
                Get FileNumber, FileListStart, DirPath  'Length posible
                DirPath = Mid(DirPath, 1, InStr(1, DirPath, Chr$(0)) - 1)
                FileListStart = FileListStart + Len(DirPath) + 1
                
                Name = String$(256, Chr$(0)): Get FileNumber, FileListStart, Name
                Name = Mid(Name, 1, InStr(1, Name, Chr$(0)) - 1)
                
                FileListStart = FileListStart + 257
                
                If Name = "" Or Offset = 0 Or Size = 0 Then
                    GoTo FinaliseError
                ElseIf LCase(Name) = LCase(DataName) Then
                    FileNumberPak = FreeFile
                    Open WinPak For Binary As FileNumberPak
                        Put FileNumberPak, Offset, Data
                    WPK_Type_ReplaceInfo = True
                    GoTo FinaliseError
                End If
            Loop Until FileListStart > LOF(FileNumber)
        End If
FinaliseError:
    Close FileNumberPak
    Close FileNumber
End Function
