Attribute VB_Name = "Mod_Initialise"
Public Sub Initialise_Load()

    Unload FrmSplash
    
    Viewer = GetStringValue("HKEY_CLASSES_ROOT\QuickView\shell\open\command", "")
    If GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt", "Product") = "" Then
        
        CreateKey "HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt"
        CreateKey "HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings"
    
        SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt", "Product", App.Major & "." & App.Minor & "." & App.Revision
        SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "ListSort", 1
        SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "ShowOpen", 0
        SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "Viewer", Viewer
        SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "VirusScan", ""
        SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "Parameters", ""
        SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "MinRun", 0
        SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "AutoFit", 1
        SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "AutoSize", 1
        SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "PromptDel", 1
        SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "CommentPop", 1
        SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "PromptDel_Success", 1
        SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "PromptRen", 1
        SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "PromptRen_Success", 1
        SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "GridLines", 0
        SetStringValue "HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "ListSort", 0
                
        FrmMain.ListFiles.GridLines = True
        FrmMain.ListFiles.Sorted = True
        
        AutoFit = True
        AutoSize = True
        PromptDelete = True
        CommentPopup = True
        DelSuccessPopup = True
        PromptRename = True
        PromptRenameSuccess = True
        
        If Command <> "" Then
            If WinPakOpen(Command, FrmMain.ListFiles) = False Then
                MessageBox "Error, could not open file.", OKOnly, Critical
                DoEvents
                Unload FrmMain
                Exit Sub
            Else
                AddToRecent Command
                ArchiveName = Command
                OpenFile
                OpenFileFeature
                If WinPakComment(Command) <> "" Then CommandShowComment
            End If
            
            Call ModListView.AutoFitColumnWidth(FrmMain.ListFiles)
            If FrmMain.ListFiles.ListItems.Count <> 0 Then Call ModListView.AutoSizeColumnWidth(FrmMain.ListFiles)
            
        Else
            If CBool(GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "ShowOpen")) = True And Command = "" Then CommandOpen
        End If
        Exit Sub
    End If
    
    DoEvents
    
    On Error GoTo FinaliseError
    
    FrmMain.ListFiles.GridLines = CBool(GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "GridLines"))
    FrmMain.ListFiles.Sorted = CBool(GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "ListSort"))
    
    Viewer = GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "Viewer")
    VirusScan = GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "VirusScan")
    Parameters = GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "Parameters")
    
    RunMinimized = CBool(GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "MinRun"))
    AutoFit = CBool(GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "AutoFit"))
    AutoSize = CBool(GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "AutoSize"))
    PromptDelete = CBool(GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "PromptDel"))
    CommentPopup = CBool(GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "CommentPop"))
    DelSuccessPopup = CBool(GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "PromptDel_Success"))
    PromptRename = CBool(GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "PromptRen"))
    PromptRenameSuccess = CBool(GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "PromptRen_Success"))
    
    If Command <> "" Then
        If WinPakOpen(Command, FrmMain.ListFiles) = False Then
            MessageBox "Error, could not open file.", OKOnly, Critical
            DoEvents
            Unload FrmMain
            Exit Sub
        Else
            If WinPakComment(Command) <> "" And CommentPopup = True Then CommandShowComment
            ArchiveName = Command
            OpenFile
            OpenFileFeature
            AddToRecent Command
            
            If AutoFit = True And FrmMain.ListFiles.ListItems.Count <> 0 Then Call ModListView.AutoFitColumnWidth(FrmMain.ListFiles)
            If AutoSize = True And FrmMain.ListFiles.ListItems.Count <> 0 Then Call ModListView.AutoSizeColumnWidth(FrmMain.ListFiles)
            
        End If
    Else
        If CBool(GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "ShowOpen")) = True And Command = "" Then CommandOpen
    End If
    
    Exit Sub
    
FinaliseError:

    DoEvents
    
    FrmMain.ListFiles.GridLines = True
    FrmMain.ListFiles.Sorted = True
    
    AutoFit = True
    AutoSize = True
    PromptDelete = True
    CommentPopup = True
    DelSuccessPopup = True
    PromptRename = True
    PromptRenameSuccess = True
    
    If CBool(GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "ShowOpen")) = True And Command = "" Then CommandOpen

    If Command <> "" Then
        If WinPakOpen(Command, FrmMain.ListFiles) = False Then
            MessageBox "Error, could not open file.", OKOnly, Critical
            DoEvents
            Unload FrmMain
            Exit Sub
        Else
            If WinPakComment(Command) <> "" And CommentPopup = True Then CommandShowComment
            ArchiveName = Command
            OpenFile
            OpenFileFeature
            AddToRecent Command
            
            Call ModListView.AutoFitColumnWidth(FrmMain.ListFiles)
            If AutoSize = True And FrmMain.ListFiles.ListItems.Count <> 0 Then Call ModListView.AutoSizeColumnWidth(FrmMain.ListFiles)
    
        End If
    Else
        If CBool(GetStringValue("HKEY_LOCAL_MACHINE\SOFTWARE\WinCrypt\Settings", "ShowOpen")) = True And Command = "" Then CommandOpen
    End If

End Sub
