Attribute VB_Name = "ModPrecache"
Function MemCache(WinPak As String, FileToCache As String) As String
    Select Case File_Method
        Case 0:
            MemCache = WPK_MemCache(WinPak, FileToCache)
    End Select
End Function

Function WPK_MemCache(WinPak As String, FileToCache As String) As String

    On Error GoTo FinaliseError
    Dim DirPath As String
    Dim Buffload As String
    
    FileNumber = FreeFile
    If WinPakValid(WinPak) = True Then
        Open WinPak For Binary As FileNumber
            Get FileNumber, Len(MainHeader) + 1, FileListStart
            If FileListStart > 0 Then
                Do
                    Get FileNumber, FileListStart, Offset
                    FileListStart = FileListStart + 4: OffSetTypes(DoCount) = Offset
                    
                    Get FileNumber, FileListStart, Size
                    FileListStart = FileListStart + 4: SizeTypes(DoCount) = Size
                    
                    DirPath = String$(65536, Chr$(0))
                    Get FileNumber, FileListStart, DirPath  'Length posible
                    DirPath = Mid(DirPath, 1, InStr(1, DirPath, Chr$(0)) - 1)
                    FileListStart = FileListStart + Len(DirPath) + 1
                    
                    Name = String$(256, Chr$(0)) 'Length posible
                    Get FileNumber, FileListStart, Name
                    Name = Mid(Name, 1, InStr(1, Name, Chr$(0)) - 1)
                    FileListStart = FileListStart + 257
                    
                    DoCount = DoCount + 1

                    If UCase(Name) = UCase(FileToCache) Then
                        Buffload = Space(SizeTypes(DoCount - 1))
                        Get FileNumber, OffSetTypes(DoCount - 1), Buffload
                        If RiffValid(Left(Buffload, 4)) = True Then
                            WPK_MemCache = Buffload
                        Else
                            If LCase(Right(FileToCache, 3)) = LCase("wav") Then
                                SetPanelCaption "The file " & FileToCache & " was not a valid wav (Riff) format. This file could be corrupt or has been renamed.", False
                                MessageBox "The file " & FileToCache & " was an invalid wav (Riff) format. This file could be corrupt or has been renamed.", OKOnly, Critical
                            Else
                                SetPanelCaption "The file " & FileToCache & " was not a valid wav (Riff) format.", False
                                MessageBox "The file " & FileToCache & " was an invalid wav (Riff) format.", OKOnly, Critical
                            End If
                            SetPanelCaption "", True
                        End If
                        GoTo FinaliseError
                    End If
                Loop Until FileListStart > LOF(FileNumber)
            End If
    Else
        Exit Function
    End If
FinaliseError:
    Close FileNumber
End Function
